//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com mladen"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  LimeGreen
#property indicator_color2  Red     
#property indicator_color3  Red
#property indicator_color4  DeepSkyBlue
#property indicator_color5  PaleVioletRed
#property indicator_color6  DimGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_style4  STYLE_DOT
#property indicator_style5  STYLE_DOT
#property indicator_style6  STYLE_DASH

//
//
//
//
//

#import "dynamicZone.dll"
   double dzBuyP(double& sourceArray[], double probabiltyValue, int lookBack, int bars, int i, double precision);
   double dzSellP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
#import

//
//
//
//
//

extern int    AroonPeriod            = 25;
extern int    Filter                 = 5;
extern double Divisor                = 50;
extern int    MpMaPeriod             = 89;
extern int    MaFilterPass           = 5;
extern int    DzLookBackBars         = 70;
extern double DzStartBuyProbability  = 0.10;
extern double DzStartSellProbability = 0.10;

//
//
//
//
//

double osc[];
double osclu[];
double oscld[];
double trend[];
double sli[];
double bli[];
double zli[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,osc);
   SetIndexBuffer(1,osclu);
   SetIndexBuffer(2,oscld);
   SetIndexBuffer(3,bli);
   SetIndexBuffer(4,sli);
   SetIndexBuffer(5,zli);
   SetIndexBuffer(6,trend);

      MaFilterPass = MathMax(MathMin(MaFilterPass,48),1);
      MpMaPeriod   = MathMax(MpMaPeriod,2);
      Divisor      = MathMin(Divisor,100);
   
   IndicatorShortName("dynamic zone mp-aroon oscillator ("+AroonPeriod+","+DoubleToStr(Divisor,2)+")");
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   if (trend[limit]==-1) CleanPoint(limit,osclu,oscld);
   for(int i=limit; i>=0; i--)
   {
      double AroonUp = 100*(AroonPeriod-iHighest(NULL,0,MODE_HIGH,AroonPeriod,i)+i)/AroonPeriod;
      double AroonDn = 100*(AroonPeriod- iLowest(NULL,0,MODE_LOW ,AroonPeriod,i)+i)/AroonPeriod;
      double Aroon   = (AroonUp-AroonDn)/Divisor;
      
      if (AroonUp != AroonDn) 
           osc[i] = iMultiPassMa(100.0*(MathExp(2.0*Aroon)-1)/(MathExp(2.0*Aroon)+1.0),MpMaPeriod,MaFilterPass,i,0);
      else osc[i] = iMultiPassMa(0                                                    ,MpMaPeriod,MaFilterPass,i,0); 
      
           bli[i] = dzBuyP (osc, DzStartBuyProbability,  DzLookBackBars, Bars, i, 0.0001);
           sli[i] = dzSellP(osc, DzStartSellProbability, DzLookBackBars, Bars, i, 0.0001);
           zli[i] = dzSellP(osc, 0.5,                    DzLookBackBars, Bars, i, 0.0001);
           
         osclu[i] = EMPTY_VALUE;
         oscld[i] = EMPTY_VALUE;
         trend[i] = trend[i+1];
            if (osc[i] > osc[i+1]) trend[i] =  1;
            if (osc[i] < osc[i+1]) trend[i] = -1;
            if (trend[i] == -1) PlotPoint(i,osclu,oscld,osc);
                  
   }
   
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double workMpFilter[][50][1];
double iMultiPassMa(double price, int period, int filterPass, int i, int instanceNo=0)
{ 
   if (ArrayRange(workMpFilter,0) != Bars) ArrayResize(workMpFilter,Bars); i = Bars-i-1; 

   double ma = 0;
   for (int p=0; p<filterPass; p++)
   {
      if (p==0) workMpFilter[i][0][instanceNo] = price;
      if (i>=period)
               ma = workMpFilter[i-1][p+1][instanceNo]+(workMpFilter[i][p][instanceNo]-workMpFilter[i-period][p][instanceNo])/period;
      else {   ma = workMpFilter[i][p][instanceNo]; for (int k=1; k<period && (i-k)>=0; k++) ma += workMpFilter[i-k][p][instanceNo];
                                                                                             ma /= k; }
      workMpFilter[i][p+1][instanceNo] = ma;
   }               
   return(ma);
} 

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
      if (first[i+2] == EMPTY_VALUE) {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
         }
      else {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
         }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}
     